<template>
  <div>
    <v-dialog
      ref="dialogStart"
      v-model="datepickerModal"
      persistent
      width="290px"
      :return-value.sync="dateInput"
      @input="handleInput"
    >
      <template v-slot:activator="{ on }">
        <v-text-field
          v-model="dateFormatted"
          :label="label"
          append-icon="event"
          readonly
          hide-details
          outlined
          dense
          clearable
          v-on="on"
        ></v-text-field>
      </template>
      <v-date-picker v-model="dateInput" scrollable range>
        <v-spacer></v-spacer>
        <v-btn text color="primary" @click="datepickerModal = false">Cancel</v-btn>
        <v-btn text color="primary" @click="$refs.dialogStart.save(dateInput)">OK</v-btn>
      </v-date-picker>
    </v-dialog>
  </div>
</template>
<script>
export default {
  props: {
    value: {
      type: Array,
      default() {
        return []
      }
    },
    rules: {
      type: Function,
      default: undefined
    },
    readonly: {
      type: String,
      default: undefined
    },
    label: {
      type: String,
      default: 'Date Picker Range'
    }
  },
  data() {
    return {
      datepickerModal: false,
      dateInput: this.value
    }
  },
  computed: {
    dateFormatted: {
      get() {
        return this.formatDate(this.dateInput)
      },
      set(value) {
        this.dateInput = value || []
      }
    }
  },
  methods: {
    handleInput(e) {
      this.$emit('input', this.dateInput)
    },
    formatDate(date) {
      if (!date) return ''
      date = date.map((el) => {
        const [year, month, day] = el.split('-')
        return `${day}-${month}-${year}`
      })
      return date.join(' ~ ')
    }
  }
}
</script>
